(
s.quit; //make sure that the server is not booted
~string = " ";
~w2 = Window.new;
~weq = Window.new;
~testestring = ""; //string used to visualize the spaces at thw window to help organize it
//////////SETS THE WINDOW SIZE
~screensize = Window.screenBounds;
~windowwidth = ~screensize.right;
~windowheight = ~screensize.bottom;
~layoutfactor = ~windowwidth-40;

~localserver = Server.local;
~rows = 1; //just to fill the arrays below, it will be overwritten later
~pitches = Array.fill(~rows,440);
~amp = Array.fill(~rows,0.8);
~pan = Array.fill(~rows,0);
~dur = Array.fill(~rows,0);
~killmsg = NetAddr("127.0.0.1", 57120);
~p4 = nil;

~freqscopesize = ~layoutfactor/2;

w = Window.new("NGFDS: Main Window",Rect(0,0,~windowwidth,~windowheight),true,scroll:true).front;
w.onClose = {
	CmdPeriod.run;
	s.quit;//quit the server when main window is closed
	(~localserver.asString ++ " Exited").postln;
	~string = (~localserver.asString ++ " Exited");
	if(~w2.isClosed.not, {~w2.close});//closes the data processing window when main window is closed
	if(~weq.isClosed.not, {~weq.close});//closes the data processing window when main window is closed
	//if(~postwindow.isClosed.not, {~postwindow.close});
	0.exit; //exit the interpreter when window is closed

};
w.view.decorator = FlowLayout(w.view.bounds,20@20,0@0);
////////////////////////////////////////////////////////////////////
///////////////////////Credits/////////////////////////////////////
//////////////////////////////////////////////////////////////////
~spacing = StaticText.new(w, ~layoutfactor*2/4@40);
~spacing.string_(~testestring);
~credits = StaticText.new(w, ~layoutfactor*2/4@40);
~credits.string_("Version: 0.1 || Developed by Nik Gomes & Joana Burd. Powered by SuperCollider.
Feedback or questions: n.ferranddis@gmail.com           ||").align_(\right);


v=UserView(w,~layoutfactor@10);
v.resize = 2;
v.background_(Color.black);

////////////////////////////////////////////////////////////////////
///////////////////////Post WINDOW/////////////////////////////////
//////////////////////////////////////////////////////////////////

~postwindowwindow = {

	a = StaticText(~compositetree3,(~layoutfactor/2)@(140)).string_((~string.asString)).align_(\center).background_(Color.white);
	r = {
		inf.do { |i|

			a.do { |item|
				{
					item.string = (~string.asString);
				}.defer;
			};
			0.15.wait;
		}
	}.fork;
};


////////////////////// I/O setup
~listofIndevices = ServerOptions.inDevices;
~listofOutdevices = ServerOptions.outDevices;

~indevicesmenu = EZListView.new(w,
	~layoutfactor/2@120,
	"Audio Input Selection",
	~listofIndevices,
	{ |a|  ~audioindevice = ~listofIndevices[a.value].asString;
		s.options.inDevice_(~audioindevice);
		("Audio input device now is "++~audioindevice).postln;
		~string = ("Audio input device now is "++~audioindevice);
	},
	initAction: true
);
~outdevicesmenu = EZListView.new(w,
	~layoutfactor/2@120,
	"Audio Output Selection",
	~listofOutdevices,
	{ |a|  ~audiooutdevice = ~listofOutdevices[a.value].asString;
		s.options.outDevice_(~audiooutdevice);
		("Audio output device now is "++~audiooutdevice).postln;
		~string = ("Audio output device now is "++~audiooutdevice);
	},
	initAction: true
);
~sboot = Button.new(w,~layoutfactor/2@30).action_({///action button

	s.waitForBoot{
		//~string = "Server Booted";
		1.wait;
		~synth = SynthDef(\sampler, { arg out = 0, bufnum = 0,rate=1, amp=1, pan = 0, dur = 1; Out.ar(out, Pan2.ar(amp*PlayBuf.ar(bufnum.numChannels,bufnum,rate,1,0,0,3,2),pan));}).add;

		//if(s.hasBooted.not,{~string = "Error: Check audio devices sample rate";});
		if(s.hasBooted,{~string = "Audio Server Open";},{~string = "Problems opening audio, please choose another device or check audio device configuration on your system.";});
		//if(~p4==nil,{
		~p4 = Buffer.read(s,"C:/NGFDSinstallationFolder/piano440hz.wav");
		//});
		s.plotTreeView(0.5,~compositetree);
		~meter = ServerMeterViewNik.new(s,~compositetree,400@0,0,2);
		~freqscopetree=CompositeView.new(~compositetree,~freqscopesize+120@340).background_(Color.white);
		~freqscop = FreqScopeNik.new(~freqscopesize,300,window:~freqscopetree);




	};

});//end of action button
~sboot.string = "Open Audio Server";
~squit = Button.new(w, ~layoutfactor/2@30).action_({
	s.quit;
	~string = ("Audio Server at "++~localserver.asString ++ " closed");
	~meter.remove;
	~killmsg.sendMsg("/killmenow");
	//kill analisers

}).string_("Close Audio Server");



//////LINHA

v=UserView(w,~layoutfactor@5);
v.resize = 2;
v.background_(Color.black);

//file load dragndrop CSV table
~dragndropCSV = DragSink(w, ~layoutfactor/2@40).align_(\center);
~dragndropCSV.string = "drop CSV file here";
/////////ignoring lines of the table
~startRow;
~numberrow = EZNumber(w,        // parent
	190@30,   // bounds
	"1st data at row:  ", // label
	ControlSpec(0,10000),    // controlSpec
	{ |ez| ( ~startRow = ez.value-1; ("read from row # "++(~startRow+1).asString).postln;~string=("read from row # "++(~startRow+1).asString);)}, // action
	0,      // initValue
	false,
	110,
	70,
	gap:20@30,
);
~numberrow.setColors(Color.grey,Color.white);

~startCol;
~numbercol = EZNumber(w,        // parent
	190@30,   // bounds
	"1st data at col:  ", // label
	ControlSpec(0,10000),    // controlSpec
	{ |ez| ( ~startCol = ez.value-1; ("read from col # "++(~startCol+1).asString).postln;~string = ("read from col # "++(~startCol+1).asString);)}, // action
	0,      // initValue
	false,
	110,
	70,
	gap:20@30,
);
~numbercol.setColors(Color.grey,Color.white);
~timenumber = EZNumber(w, 190@30, "File Duration (s): ",
	ControlSpec(0,10000,units:"s"), { |ez| (
		~time= ez.value;
		("Estimated time of audio file: " ++~time++" seconds.").postln;
		~string = ("Estimated time of audio file: " ++~time++" seconds.");
		~dur = Array.fill(~rows,(~time/~rows));
	)},
	30,
	true,
	110,
	70
);
~timenumber.setColors(Color.grey,Color.white);


////////////////////////////////////////////////////////////////////
///////////////////////LOAD CSV BUTTON//////////////////////////////
////////////////////////////////////////////////////////////////////
b = Button.new(w,~layoutfactor/2@30).action_({//aqui comeca a function do botao

	~csv = CSVFileReader.readInterpret(~dragndropCSV.object;,true,true,startRow: ~startRow);
	~rows = ~csv.size; //descobre a quantidade de linhas no arquivo
	~cols = ~csv[0].size; //descobre a quantidade de colunas no arquivo
	~pitches = Array.fill(~rows,60);
	~amp = Array.fill(~rows,0.8);
	~pan = Array.fill(~rows,0);
	//~dur = Array.fill(~rows,0.01);
	~table = Array2D.new(~rows,~cols);
	~newcol = Array.fill(~cols);

	for (0, ~cols-1,
		{ arg j;
			for (0, ~rows-1,
				{ arg i;
					~point=~csv[i].asArray;
					~table.put(i,j,~point[j]);
			});

	});

	for (0, ~cols-1, {arg j;

		~newcol.put(j, ~table.colAt(j));
	});
	~dur = Array.fill(~rows,(~time/~rows));
	"New DATA set:".postln;
	"with ".post;
	~rows.post;
	" rows and ".post;
	~cols.post;
	" columns".postln;
	~string = (	"New data set with "++~rows.asString++" rows and "++~cols.asString++" columns");



});//aqui termina a function do botao
b.string = "Load CSV file";
////////////////////////////////////////////////////////////////////
////////////////////READ DATA BUTTON////////////////////////////////
////////////////////////////////////////////////////////////////////
~readbut = Button.new(w,~layoutfactor/2@30).action_({
	~minvaluesatcol = Array.new(~cols);
	~maxvaluesatcol = Array.new(~cols);
	for (0, ~cols-1,
		{ arg i;
			~minvaluesatcol.add((~table.colAt(i)).minItem);
			~maxvaluesatcol.add((~table.colAt(i)).maxItem);
	});

	~dataprocessingwindow.value;

});
~readbut.string = "Open Data Processing Window";

///////line
v=UserView(w,~layoutfactor@5,);
v.resize = 2;
v.background_(Color.black);

~mapbut = Button.new(w,~layoutfactor@30).action_({

	~parametermappingwindow.value;

});
~mapbut.string = "Open Parameter Mapping Window";


v=UserView(w,~layoutfactor@5);/////LINE/////
v.resize = 2;
v.background_(Color.black);



////3rd line
v=UserView(w,~layoutfactor@5,);
v.resize = 2;
v.background_(Color.black);


~samplefile = StaticText(w, ~layoutfactor/4@40).string_("Loaded Sample: ").align_(\center).background_(Color.gray(0.4,0.2));
b = StaticText(w, ~layoutfactor*3/4@40)
.string_(~p4.asString)
.align_(\center)
.background_(Color.white);
r = {
	inf.do { |i|

		b.do { |item|
			{
				item.string = (if((~p4==nil).not,{~p4.path.asString}););
			}.defer;
		};
		0.15.wait;
	}
}.fork;

//file load dragndrop sample
~dropsample = DragSink(w, ~layoutfactor/2@40).align_(\center);
~dropsample.string = "drop sample here";

//botao
~butsample = Button.new(w,~layoutfactor/8@40).action_({//aqui comeca a function do botao
	~p4 = Buffer.read(s,~dropsample.object;);
	"New Sample from: ".postln;
	~dropsample.object.postln;
	~string = ("New Sample from: "++~dropsample.object.asString);

});//aqui termina a function do botao

~butsample.string = "Load sample";

/////////////////////////play instrument button
~playbutton = Button.new(w,~layoutfactor/8@40);
~playbutton.states_([["Play"],["Stop", Color.white, Color.black]]);
~playbutton.action_({//aqui comeca a function do botao
	~serverbooted = s.hasBooted;
	~playstate=~playbutton.value;
	if(~playstate==0,{
		////////STOP EVERYTHING////////
		CmdPeriod.run;
		~string="stoping";
		s.free
	});

	if(~playstate==1,{
		if(~serverbooted == true ,  {
			k = Pbind(
				\instrument, \sampler,
				\bufnum, ~p4,
				\dur, Pseq(~dur),
				\rate, Pseq(~pitches.linlin(16, 20000, 0.03636364, 45.45454545)),
				\amp, Pseq(~amp*0.5),
				\pan, Pseq(~pan)
			).play;
			"playing".postln;~string="playing";

		},{
			"Server Not Booted".postln;
			"Please press 's.boot'".postln;
			~string = "Audio Server not open; check your audio device options and try again.";
			~playbutton.value=0;
		});
	});
});//aqui termina a function do botao
~playbutton.string = "Play";


/////record button code//////
~recorder = Recorder(s);
~recordpathbutton=Button.new(w, ~layoutfactor/8@40);
~recordpathbutton.string = "Save Record As";
~recordpathbutton.action = {
	Dialog.savePanel({
		arg path;
		~path = path;
		~path.size;
		if(~path.containsStringAt(~path.size-4,".wav")==false,{~path = ~path++".wav";});
		~string="saving file as "++~path.asString;
	},{"cancelled".postln;
		~string="cancelled";
	});

};

~recordbutton = Button.new(w, ~layoutfactor/8@40);
~recordbutton.states_([["Record", Color.black, Color.red],["Stop Record", Color.white, Color.black]]);
~recordbutton.action_({
	~state=~recordbutton.value;
	if(s.hasBooted.not,{~string="Audio Not Running";~recordbutton.value_(0);},{
		if(~state==0,{

			"and cut!".postln;
			~string="Record Stopped: "++"("++~recorder.path.asString++")";
			~recorder.stopRecording;
		});

		if(~state==1,{"ACTION!!".postln;
			~recorder.record(~path,0,2);
			~string="recording at: "++~recorder.path.asString;});
	});
});





//////POST WINDOW BUTTON//////
/*~postbutton=Button.new(w,~layoutfactor/4.1@40).action_({
if(~postwindow.isClosed.not, {~postwindow.close});
~postwindowwindow.value;
}).string_("Open Post Window");*/
//////spacer

~spacing = StaticText.new(w, ~layoutfactor*3/4@40);
~spacing.string_(~testestring);

///////Master fader////////
~masterfader = EZSlider.new(w,
	~layoutfactor/4@40,
	"Master Volume",
	\db,
	{|ez|(s.volume_(ez.value););},
	0,
	true);
~compositetree = CompositeView.new(w,~layoutfactor@340).background_(Color.grey);
~compositetree.decorator_(FlowLayout.new(~compositetree.bounds,0@0,0@0));
//~compositetree2 = CompositeView.new(w,~layoutfactor*12/16@340).background_(Color.grey);
//~compositetree = CompositeView.new(w,~layoutfactor*/16@340).background_(Color.grey);
~compositetree3 = CompositeView.new(w,~layoutfactor/2@140).background_(Color.grey);
~postwindowwindow.value;
////////////////////////////////////////////////////////////////////
///////////////////////DATA PROCESSING WNDOW////////////////////////
////////////////////////////////////////////////////////////////////

~dataprocessingwindow = {
	~reduction = 2;
	~layoutfactor2 = (~windowwidth/~reduction);
	~w2 = Window.new("Data Processing",
		Rect(~windowwidth*3/5,
			~windowheight-(~cols*100),
			~windowwidth/~reduction,
			(~cols*100)),
		true,scroll:true).front;
	~w2.onClose = {

	};
	~w2.view.decorator = FlowLayout(~w2.view.bounds,0@0,0@0);
	////ALL NEEDED ARRAYS FOR THIS WINDOW
	~colmappingtext = Array.fill(~cols);
	~textmin = Array.fill(~cols);
	~textmax = Array.fill(~cols);
	~spacer0 = Array.fill(~cols);
	~spacer1 = Array.fill(~cols);
	~newminvaluecol = Array.fill(~cols);
	~newmin= Array.fill(~cols);
	~newmaxvaluecol= Array.fill(~cols);
	~newmax= Array.fill(~cols);
	~linmapbut= Array.fill(~cols);
	~logmapbut= Array.fill(~cols);
	~colmapped= Array.fill(~cols);
	~line= Array.fill(~cols);


	for (0, ~cols-1,
		{ arg i;
			/////1st col data set processing
			~colmappingtext.put(i,{StaticText(~w2, ~layoutfactor2/4@40,).string_(" col " ++(i+1).asString).align_(\center);});
			~textmin.put(i,{EZText( ~w2,~layoutfactor2/4@40,"Min Value     ",{ |ez|  },	 ~minvaluesatcol[i],false,~layoutfactor2/11).setColors(Color.grey,Color.white);});
			~textmax.put(i,{EZText( ~w2,~layoutfactor2/4@40,"Max Value     ", { |ez|  },  ~maxvaluesatcol[i],false,~layoutfactor2/11,).setColors(Color.grey,Color.white);});
			~spacer0.put(i,{StaticText(~w2, ~layoutfactor2/4@40).string_(~testestring).align_(\center);});
			~spacer1.put(i,{StaticText(~w2, ~layoutfactor2/4@40).string_(~testestring).align_(\center);});
			~newminvaluecol.put(i,{EZNumber(~w2,~layoutfactor2/4@40,"New Min     ",ControlSpec(-20000,20000),{|ez| ~newmin.put(i,ez.value);},0,false,~layoutfactor2/11,).setColors(Color.grey,Color.white);});
			~newmaxvaluecol.put(i,{EZNumber(~w2,~layoutfactor2/4@40,"New Max     ",ControlSpec(-20000,20000),{|ez| ~newmax.put(i,ez.value);},0,false,~layoutfactor2/11,).setColors(Color.grey,Color.white);});

			~linmapbut.put(i,{Button.new(~w2, ~layoutfactor2/9@40).string_("Lin Map").action_({"LINMAP".postln; ~string = "LINMAP";
				~colmapped.put(i,{~newcol.put(i,~table.colAt(i).linlin((~table.colAt(i)).minItem,(~table.colAt(i)).maxItem, ~newmin[i], ~newmax[i]))});
				~colmapped[i].value;

			});});

			~logmapbut.put(i,{Button.new(~w2, ~layoutfactor2/9@40).string_("Log Map").action_({"LOGMAP".postln;~string = "LOGMAP";
				~colmapped.put(i,{~newcol.put(i,~table.colAt(i).linexp((~table.colAt(i)).minItem,(~table.colAt(i)).maxItem, ~newmin[i], ~newmax[i]))});
				~colmapped[i].value;
			});});

			~line.put(i,{UserView(~w2,~layoutfactor2@5).resize_(2).background_(Color.black);});

			~colmappingtext[i].value;
			~textmin[i].value;
			~textmax[i].value;
			~spacer0[i].value;
			~spacer1[i].value;
			~newminvaluecol[i].value;
			//~newmin[i].value;
			~newmaxvaluecol[i].value;
			//~newmax[i].value;
			~linmapbut[i].value;
			~logmapbut[i].value;
			//~colmapped[i].value;
			~line[i].value;
	});

};

//////////////////////////////////////////////////////////////////
////////////////////Parameter Mapping WNDOW///////////////////////
//////////////////////////////////////////////////////////////////
~parametermappingwindow = {

	~mapping = Window.new("Parameter Mapping",Rect(0,0,~windowwidth*2.03/3,(~cols/2*50)+55),scroll:true).front;
	~mapping.view.decorator = FlowLayout(~mapping.view.bounds,0@0,0@0);
	~layoutfactor3 = ~windowwidth*2/4;
	~menuSize = ~layoutfactor3/2;

	g = Array.fill(~cols);
	h = Array.fill(~cols);
	////1st col
	for(0, ~cols-1, {arg i;

		g[i] = {h[i]=EZPopUpMenu.new(~mapping, ~menuSize@40, ("col "++(i+1)));};
		g[i].value;
		h[i].addItem(\choose);
		h[i].addItem(\pitch, { |a| //inicio funcao parametro pitch
			~pitches = Array.new(~rows);
			for(0, ~rows-1,
				{arg j;
					//~pitches.add(~table[i,0]);
					~pitches.add(~newcol[i][j]);
			});
			~pitches.postln;
			~string = "new picthes values array";
		});// final funcao parametro pitch
		h[i].addItem(\amp, { |a| //inicio funcao parametro amp
			~amp = Array.new(~rows);
			for(0, ~rows-1,
				{arg j;
					~amp.add(~newcol[i][j]);
			});
			~amp.postln;
			~string = "new amp values array";
		});// final funcao parametro amp
		h[i].addItem(\pan, { |a| //inicio funcao parametro pan
			~pan = Array.new(~rows);
			for(0, ~rows-1,
				{arg j;
					~pan.add(~newcol[i][j]);
			});
			~pan.postln;
			~string =  "new pan values array";
		});// final funcao parametro pan
		h[i].addItem(\dur, { |a| //inicio funcao parametro pan
			~dur = Array.new(~rows);
			for(0, ~rows-1,
				{arg j;
					~dur.add(~newcol[i][j]);
			});
			~dur.postln;
			~string =  "new duration value array";
		});// final funcao parametro pan

		h[i].value = 0;
	};);


	v=UserView(~mapping,~layoutfactor3@5,);
	v.resize = 2;
	v.background_(Color.black);
	~spacermenus = StaticText(~mapping, ~layoutfactor3/3@40).string_(~testestring).align_(\center);

	~newtablebutton = Button.new(~mapping, ~layoutfactor3/3@40).string_("See New Table").action_({
		//visualizar os dados
		t = TreeView(z,Rect(~layoutfactor-(~cols*100),0,~cols*100,~windowheight)).front;
		~tcolumns = Array.fill(~cols);
		for (0, ~cols-1, {arg i;~tcolumns.put(i, h[i].item.asString);});
		t.columns = ~tcolumns;
		for(0,~rows-1, {arg j;~trows=Array.fill(~cols);for(0, ~cols-1,{arg i;~trows.put(i,~newcol[i][j]);});t.addItem(~trows);});
	};);

	///2nd line
	v=UserView(~mapping,~layoutfactor3@5,);
	v.resize = 2;
	v.background_(Color.black);
};


)//end of gui all